import datetime
import multiprocessing
import time
import json
import crawler_baidu
import crawler_boss
import random
import requests
import cyaml

#获取需要爬数据的企业 百度1
def GetCompany(types):
    response = requests.get(cyaml.data[cyaml.data["env"]]["url"]+cyaml.data["php-api"]["getcompany"]+"?type="+str(types), headers={"Content-Type": "application/json"})
    if response.status_code == 200:
        response_data = response.json()
        # if response_data.get('name') is not None:
        #return "上海临方股权投资管理有限公司","https://www.zhipin.com/web/geek/job?query=%E5%A4%A7%E6%97%8F%E6%BF%80%E5%85%89&city=100010000"
        #return "上海临方股权投资管理有限公司","https://baike.baidu.com/item/%E4%B8%8A%E6%B5%B7%E4%B8%B4%E6%96%B9%E8%82%A1%E6%9D%83%E6%8A%95%E8%B5%84%E7%AE%A1%E7%90%86%E6%9C%89%E9%99%90%E5%85%AC%E5%8F%B8?fromModule=lemma_search-box"
        return response_data["data"]["company_name"],response_data["data"]["url"]
    return "", ""


#回传爬虫获取到的数据
def SaveCompanyData(name,types,intro):
    my_obj={}
    my_obj["intro"] = intro
    post_data = {
        "name": name,
        "content": json.dumps(my_obj),
        "type": types
    }
    json_data = json.dumps(post_data)
    response = requests.post(cyaml.data[cyaml.data["env"]]["url"]+cyaml.data["php-api"]["getcompany"], data=json_data, headers={"Content-Type": "application/json"})
    # Log("保存数据时候的返回：" + response)
    # 检查响应状态码
    if response.status_code == 200:
        response_data = response.json()
        if response_data["code"]==200:
            return name
        else:
            return ""
    else:
        return ""



#启动爬虫
def CrawlerLaunch():
    while True:
        now = datetime.datetime.now()
        randomtime = random.randint(3, cyaml.data[cyaml.data["env"]]["randomtime"])
        print(str(now) + ":启动等待时间"+str(randomtime))
        time.sleep(randomtime)
        res1 = crawler_baidu.CrawlerBaidu()
        if res1==100:
            time.sleep(5)
            crawler_boss.CrawlerBoss()

def Log(dataS):
    with open("log/"+str(datetime.date.today()) + ".txt", "a+") as f:
        f.write(dataS + "\n")
        f.close()


if __name__ == "__main__":
    p = multiprocessing.Process(target=CrawlerLaunch)
    p.start()
    p.join()

