from playwright.sync_api import Playwright, sync_playwright, expect

import re
import json
import cyaml
import crawler

#爬虫启动
def CrawlerBaidu():
    with sync_playwright() as playwright:
        return GetBaiduCompany(playwright)

#爬取百度的数据
def GetBaiduCompany(playwright: Playwright) -> int:
    browser = playwright.chromium.launch(headless=cyaml.data[cyaml.data["env"]]["headless"])
    context = browser.new_context(viewport={"width": 800, "height": 600})
    page = context.new_page()
    #获取需要爬取数据的公司
    name,url = crawler.GetCompany(1)
    crawler.Log(name + "-百度开始请求数据：" + url)
    if url!="":
        page.goto(url)
        all = page.locator(".lemma-summary").all_text_contents()
        intro = re.sub(r'\[[\d-]+\]', '', str(all))
        crawler.Log(name+"-获取到百度数据："+intro)
        if name != "" and intro != '[]':
            intro_new = str(intro[2:len(intro) - 2])
            new_string1 = re.sub(r'\\n', "", intro_new)
            new_string2 = re.sub(r'\\xa0', "", new_string1)

            name2 = crawler.SaveCompanyData(name, 1, new_string2)
            if name2 != "":
                crawler.Log(name2+":百度数据，写入成功")
                return 100
            else:
                crawler.Log(name + ":百度数据，写入失败")
                return 100
        else:
            name2 = crawler.SaveCompanyData(name, 1, "")
            crawler.Log(name +":百度数据，写入失败")
            return 100

        # ---------------------
        context.close()
        browser.close()
    return 100
